#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define BUF_SIZE 2000
static char request_area[BUF_SIZE+1]; /* tutaj zapiszemy parametry wejsciowe */ 

int main(int argc, char *argv[], char *env[]) 
{ 
	char *p;
	char *token;
	int j,k;
	//wypisanie naglowka dokumentu HTML
	printf("Content-type: text/html\012\015\012");
	printf("<HTML>\r\n  <HEAD>\r\n"); 
	printf("   <TITLE> CGI demo - get request </TITLE>\r\n"   /* Tytul strony */ 
         "  </HEAD>\r\n"
         "<BODY>"
         "<center>\r\n"
         "   <h1> CGI demo  </h1>\r\n"
         "</center>\r\n"); 
	// wypisanie zmiennych srodowiskowych
	printf("<H2>Zmienne srodowiskowe CGI</h2>\r\n"); 
	printf("<PRE>");
	p="REQUEST_METHOD";                ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="AUTH_TYPE";                     ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="CONTENT_LENGTH";                ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="CONTENT_TYPE";                  ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="GATEWAY_INTERFACE";             ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="PATH_INFO";                     ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="PATH_TRANSLATED";               ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="QUERY_STRING"                   ; printf("%s=%s;\r\n",p,getenv(p));
	p="REMOTE_ADDR";                   ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="REMOTE_HOST";                   ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="REMOTE_IDENT";                  ; printf("%s=%s;\r\n",p,getenv(p));
	p="REMOTE_USER";                   ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="SCRIPT_NAME";                   ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="SERVER_NAME";                   ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="SERVER_PORT";                   ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="SERVER_PROTOCOL";               ; printf("%s=%s;\r\n",p,getenv(p)); 
	p="SERVER_SOFTWARE";               ; printf("%s=%s;\r\n",p,getenv(p)); 
	printf("</PRE>");
	printf("<H2>Parametry wejsciowe:</h2>\r\n"); 

	// badamy metode przekazania parametrow
	p=getenv("REQUEST_METHOD");
	if (p==NULL)
	{ 
		printf("<P> Blad !!! Nieokreslona metoda - Request metod unknown</P>\r\n"); 
		return 0; 
  	}
	printf("<P> Request method: %s </P>",p);
	// obsluga metody GET
	if (!strcmp(p,"GET"))
	{
      		p = getenv("QUERY_STRING");
      		if (p!=NULL) strncpy(request_area,p,strlen(p)); /**/
		request_area[strlen(p)]=0;
	  	while ((token=strsep(&p,"&")) != NULL)
		{
	  		printf("%s<br>", token);
	  	};
	  	if (token != NULL ) printf ("%s<br>", token);
  	}  
  
	// obsluga metody POST
  	else if (!strcmp(p,"POST"))  
	{
      		p = getenv("CONTENT_LENGTH"); 
      		if (p==NULL)
		{
	     		printf("<P> System error: content length missing</p>\r\n"); return 0; 
		}
      		sscanf(p,"%d",&k); 
      		printf("<P> content length %d <BR>\r\n",k);
      		for (j=0;j<k;j++) 
		{
			char zn = getchar();
			request_area[j] = zn;
			if(zn =='&') printf("<br>");
				else printf("%c", zn);
		}
		printf("</P>");	
      		request_area[j]=0;
	}  
	//ew. obsluga innej metody lub bledu
	else 
	{ 
     		printf("<P> Parameter error: request method not served by this program</P>\r\n"); 
	  	return 0; 
	}
	//wypisanie formularza do metody POST
	printf("<br><form method='POST'>\r\n<input name='parametr1'><INPUT type='submit' value='ok'></form>\r\n");
	printf("</BODY></HTML>\r\n");
}
